import jq.qde.space.value.QualitativeDirection;


/**
 * @author oursland
 */
public class ConstraintFunctions {
	public static boolean addition(QualitativeDirection p, QualitativeDirection q, QualitativeDirection r) {
		switch(p.key) {
			case QualitativeDirection.INC_KEY: {
				switch(q.key) {
					case QualitativeDirection.INC_KEY:
					case QualitativeDirection.STD_KEY: return r.key == QualitativeDirection.INC_KEY;
					case QualitativeDirection.DEC_KEY: return true;
				}
			}
			case QualitativeDirection.STD_KEY: {
				switch(q.key) {
					case QualitativeDirection.INC_KEY: return r.key == QualitativeDirection.INC_KEY;
					case QualitativeDirection.STD_KEY: return r.key == QualitativeDirection.STD_KEY;
					case QualitativeDirection.DEC_KEY: return r.key == QualitativeDirection.DEC_KEY;
				}
			}
			case QualitativeDirection.DEC_KEY: {
				switch(q.key) {
					case QualitativeDirection.INC_KEY: return true;
					case QualitativeDirection.STD_KEY:
					case QualitativeDirection.DEC_KEY: return r.key == QualitativeDirection.DEC_KEY;
				}
			}
		}
		return false;
	}
	
	public static boolean multiplication(QualitativeDirection p, QualitativeDirection q, QualitativeDirection r) {
		switch(p.key) {
			case QualitativeDirection.INC_KEY: {
				switch(q.key) {
					case QualitativeDirection.INC_KEY: return r.key == QualitativeDirection.INC_KEY;
					case QualitativeDirection.STD_KEY: return r.key == QualitativeDirection.STD_KEY;
					case QualitativeDirection.DEC_KEY: return r.key == QualitativeDirection.DEC_KEY;
				}
			}
			case QualitativeDirection.STD_KEY: {
				switch(q.key) {
					case QualitativeDirection.INC_KEY: return r.key == QualitativeDirection.STD_KEY;
					case QualitativeDirection.STD_KEY: return r.key == QualitativeDirection.STD_KEY;
					case QualitativeDirection.DEC_KEY: return r.key == QualitativeDirection.STD_KEY;
				}
			}
			case QualitativeDirection.DEC_KEY: {
				switch(q.key) {
					case QualitativeDirection.INC_KEY: return r.key == QualitativeDirection.DEC_KEY;
					case QualitativeDirection.STD_KEY: return r.key == QualitativeDirection.STD_KEY;
					case QualitativeDirection.DEC_KEY: return r.key == QualitativeDirection.INC_KEY;
				}
			}
		}
		return false;
	}
}
