import jq.qde.space.QualitativeVariable;
import jq.qde.space.VariableQuantitySpace;
import jq.qde.space.value.QualitativeDirection;
import jq.qde.space.value.QualitativeValue;
import jq.qsim.VariablePossibleValues;

/**
 * @author oursland
 */
public class TestInitialState {

	public static void main(String[] args) {
		final QualitativeVariable x = new QualitativeVariable("x"); // "height(ball)"
		final String[] xqsa = {"0", "a", "b", "c", "d", "inf"};

		VariableQuantitySpace qspace = new VariableQuantitySpace(x, xqsa);
		
		QualitativeValue state = new QualitativeValue(qspace, x.getInterval("b", "inf"), QualitativeDirection.STD);
		System.out.println("Known State:");
		System.out.print("\t");
		System.out.println(state.toSpecification());
		
		VariablePossibleValues tuple = state.getInitialValues();
		System.out.println("Possible States");
		tuple.printSpecification(System.out, "\t");
		System.out.println();
	}
}
