package jq.qde.constraint;

import java.io.PrintStream;

import jq.qde.QualitativeConstraint;
import jq.qde.space.value.QualitativeValue;

/**
 * @author oursland
 */
public class ConstraintValidationResult {
	public final boolean isValid;
	public final String msg;
	public final QualitativeConstraint constraint;
	public final QualitativeValue[] values;
	public ConstraintValidationResult(boolean isValid, String msg, QualitativeConstraint constraint, QualitativeValue[] values) {
		this.isValid = isValid;
		this.msg = msg;
		this.constraint = constraint;
		this.values = (QualitativeValue[]) values.clone();
	}
	public void print(PrintStream out) {
		out.print(constraint.getName());
		for (int i = 0; i < values.length; i++) {
			System.out.print("\t");
			System.out.print(values[i].toSpecification());
		}
		out.print("\t"+msg);
	}
}
