package jq.qde.constraint;

import jq.qde.space.QualitativeVariable;



/**
 * @author oursland
 */
public class MagnitudeDelta {
	private static final int VALUE = 0;
	private static final int DIRECTION = 1;
	 
	public static MagnitudeDelta createValueChange(QualitativeVariable var) {
		return new MagnitudeDelta(var, VALUE);
	}
	
	public static MagnitudeDelta createDirectionChange(QualitativeVariable var) {
		return new MagnitudeDelta(var, DIRECTION);
	}
	 
	private final QualitativeVariable var;
	private final int type;
	
	private MagnitudeDelta(QualitativeVariable var, int type) {
		this.var = var;
		this.type = type;
	}

	public QualitativeVariable getVariable() {
		return var;
	}

	public boolean isDirectionChange() {
		return this.type == DIRECTION;
	}

	public boolean isValueChange() {
		return this.type == VALUE;
	}
}
