package jq.qde.space;

import java.io.PrintStream;
import java.util.Iterator;
import java.util.ListIterator;
import jq.qde.space.value.MagnitudeLandmark;
import jq.qde.space.value.QualitativeDirection;
import jq.qde.space.value.QualitativeMagnitude;
import jq.qde.space.value.QualitativeValue;

/**
 * @author oursland
 */
public interface QuantitySpace {
	public QuantitySpace addAfter(MagnitudeLandmark prevLM, MagnitudeLandmark newLM);

	public Iterator landmarkIterator();
	public ListIterator landmarkListIterator();

	public MagnitudeLandmark getLandmarkValue(String name);

	public int getQValueCount();
	public QualitativeMagnitude getQValue(int index);
	public int getQSpaceIndex(QualitativeMagnitude mag);

	public boolean lessThan(MagnitudeLandmark value, MagnitudeLandmark high);
	public QualitativeDirection compare(QualitativeMagnitude magnitude, QualitativeMagnitude landmark);
	public QualitativeDirection getSign(QualitativeMagnitude magnitude);
	public boolean isNegative(QualitativeMagnitude mag);
	public boolean isPositive(QualitativeMagnitude mag);
	public boolean isLowEnd(QualitativeMagnitude magnitude);
	public boolean isHighEnd(QualitativeMagnitude magnitude);
	public boolean isDiverging(QualitativeValue v);
	public boolean isEnd(QualitativeMagnitude mag);

	public QualitativeMagnitude shiftMagnitude(QualitativeMagnitude mag, int i);

	public void printSpecification(PrintStream out, String prefix);
}