package jq.qde.space;

import jq.qde.space.value.MagnitudeInterval;
import jq.qde.space.value.MagnitudeLandmark;
import jq.qde.space.value.TimeInterval;
import jq.qde.space.value.TimeLandmark;


/**
 * @author oursland
 */
public class TimeVariable extends QualitativeVariable {
//	private String landmarkPrefix;
	protected final TimeQuantitySpace qspace;
	public TimeVariable(String landmarkPrefix) {
		super("time");
		setLandmarkPrefix(landmarkPrefix);
//		this.landmarkPrefix = landmarkPrefix;
		this.qspace = new TimeQuantitySpace(this);
	}

	protected MagnitudeLandmark createLandmark(String name) {
		int i = prefix.length();
		int id = Integer.parseInt(name.substring(i));
		return new TimeLandmark(id, this);
	}
	
	public String createName(int id) {
		return prefix+id;
	}
	
	protected MagnitudeInterval createInterval(MagnitudeLandmark low, MagnitudeLandmark high) {
		return new TimeInterval((TimeLandmark)low, (TimeLandmark)high);
	}
}
