package jq.qde.space.value;

import jq.qde.space.QualitativeVariable;

/**
 * @author oursland
 */
public class InfiniteLandmark extends MagnitudeLandmark {
	private static final String			INF		= "inf";
	private static final String			MINF	= "minf";
	private final QualitativeDirection	sign;

	public static InfiniteLandmark createInf(QualitativeVariable var) {
		return new InfiniteLandmark(INF, var, QualitativeDirection.POSITIVE);
	}

	public static InfiniteLandmark createMinusInf(QualitativeVariable var) {
		return new InfiniteLandmark(MINF, var, QualitativeDirection.NEGATIVE);
	}

	private InfiniteLandmark(String name, QualitativeVariable var, QualitativeDirection sign) {
		super(name, var);
		this.sign = sign;
	}

	public boolean isInfinite() {
		return true;
	}

	public QualitativeDirection getInfiniteSign() {
		return sign;
	}
}