package jq.qde.space.value;

import jq.qde.space.QualitativeVariable;
import jq.qde.space.VariableQuantitySpace;




/**
 * @author oursland
 */
public class UnknownMagnitude extends MagnitudeLandmark {
		
	public UnknownMagnitude(QualitativeVariable var) {
		super("?", var);
	}

	public boolean isUnknown() {
		return true;
	}
	
	public boolean isAssignable(MagnitudeLandmark nextValue) {
		return true;
	}
	public boolean isPositive() {
		throw new Error("Unknown value has is neither positive nor negative.");
	}

	public boolean isNegative() {
		throw new Error("Unknown value has is neither positive nor negative.");
	}

	public QualitativeMagnitude[] getInitialValues(VariableQuantitySpace qspace) {
		final int qValueCount = qspace.getQValueCount();
		QualitativeMagnitude[] rc = new QualitativeMagnitude[qValueCount];
		for (int i = 0; i < rc.length; i++) {
			rc[i] = qspace.getQValue(i);
		}
		return rc;
	}
}
