package jq.qsim;

import jq.qde.space.value.QualitativeValue;

/**
 * @author oursland
 */
public class ValueTuple {
	private final QualitativeValue[] tupleValues;
	
	public ValueTuple(QualitativeValue[] tupleValues) {
		this.tupleValues = (QualitativeValue[]) tupleValues.clone();
	}

	public ValueTuple(int count) {
		tupleValues = new QualitativeValue[count];
	}

	public ValueTuple(QualitativeValue x) {
		tupleValues = new QualitativeValue[1];
		assert tupleValues.length == 1;
		tupleValues[0] = x;
	}

	public ValueTuple(QualitativeValue x, QualitativeValue y) {
		tupleValues = new QualitativeValue[2];
		assert tupleValues.length == 2;
		tupleValues[0] = x;
		tupleValues[1] = y;
	}

	public ValueTuple(QualitativeValue x, QualitativeValue y, QualitativeValue z) {
		tupleValues = new QualitativeValue[3];
		assert tupleValues.length == 3;
		tupleValues[0] = x;
		tupleValues[1] = y;
		tupleValues[2] = z;
	}

	public QualitativeValue getValue(int index) {
		return tupleValues[index];
	}

	public int size() {
		return tupleValues.length;
	}

	public String toSpecification() {
		StringBuffer rc = new StringBuffer();
		for (int i = 0; i < tupleValues.length; i++) {
			if( i > 0 ) {
				System.out.print("\t");
			} 
			rc.append(tupleValues[i].toSpecification());
		}
		return rc.toString();
	}
	
	public String toAbbreviation() {
		StringBuffer rc = new StringBuffer();
		for (int i = 0; i < tupleValues.length; i++) {
			if( i > 0 ) rc.append(" ");
			rc.append(tupleValues[i].toAbbreviation());
		}
		return rc.toString();
	}
}
